<html lang="en" xlmns:th="http://www.thymeleaf.org" xlmns:layout="http://ultraq.net.nz/thymeleaf/layout"
	layout:decorate="~{fragments/layout}">

<head>
	<title>Variants API Pages</title>
</head>

<body>
	<div layout:fragment="content">
		<h1>VARIANTS API</h1>
		<br>
		<div class="form-outline mb-4">
			<input type="text" class="form-control" id="key" onkeyup="search(this.value.toLowerCase())"
				placeholder="Search">
		</div>
		<div class="p-3 mb-2 bg-primary text-white">
			<button type="button" class="btn btn-light" onclick="openModalVar()">
				Create New
			</button>
		</div>
		<div id="inputdata"></div>

		<script>
			$(function () {
				getAllVariants()
			})
			function getAllVariants() {
				$.ajax({
					url: '/api/variants',
					type: 'get',
					contentType: 'application/json',
					success: function (datavariants) {
						var data = "<table class='table' 'border=1'>"
						data += "<thead>"
						data += "<tr>"
						data += "<th>Category</th>"
						data += "<th>Initial</th>"
						data += "<th>Name</th>"
						data += "<th style='text-align:center'>Active</th>"
						data += "<th colspan = '2' style='text-align:center'>Action</th>"
						data += "</tr>"
						data += "</thead>"
						data += "<tbody>"
						for (var i = 0; i < datavariants.length; i++) {
							data += "<tr>"
							data += "<td>" + datavariants[i].category.categoryName + "</td>"
							data += "<td>" + datavariants[i].initial + "</td>"
							data += "<td>" + datavariants[i].name + "</td>"
							data += "<td style='text-align:center'><input type='checkbox' name='active' checked disabled></td>"
							data += "<td style='text-align:center'><button class='btn btn-warning'; onclick='edit(" + datavariants[i].id + ")';>Edit</button></td>"
							data += "<td style='text-align:center'><button class='btn btn-danger'; onclick='cekhapus(" + datavariants[i].id + ")';>Delete</button></td>"
							data += "</tr>"
						}
						data += "</tbody>"
						data += "</table>"

						$('#inputdata').html(data)
					}
				})
			}
			function openModalVar() {
				$.ajax({
					url: '/api/category',
					type: 'get',
					contentType: 'application/json',
					success: function (data1) {
						var data = "<form>"
						data += "<input type='hidden' value =0 id='idvariants'>"
						data += "<div class='form-group'>"
						data += "<label>Category</label>"
						data += "<select class='form-control' id='categoryId'>"
						data += "<option>Pilih</option>"
						for (var i = 0; i < data1.length; i++) {
							data += "<option value='" + data1[i].id + "'>" + data1[i].categoryName + "</option>"
						}
						data += "</select>"
						data += "</div>"
						data += "<div class ='form-group'>"
						data += "<label>Initial</label>"
						data += "<input type='text' class='form-control' id='initial'>"
						data += "</div>"
						data += "<div class='form-group'>"
						data += "<label>Name</label>"
						data += "<input type='text' class='form-control' id='name'>"
						data += "</div>"
						data += "<div class='form-group form-check'>"
						data += "<input type='checkbox' class='form-check-input' id='active'>"
						data += "<label class='form-check label'>Active</label>"
						data += "</div>"
						data += "</form>"

						$('.modal-title').html('Variants Form')
						$('.modal-body').html(data)
						$('#btn-save').off('click').on('click', saveVariants).html('Create').addClass("btn btn-success")
						$('#modal').modal('show')

					}
				})
			}
			function saveVariants() {
				var idcat = $('#categoryId').val()
				var id = $('#idvariants').val()
				var initial = $('#initial').val()
				var name = $('#name').val()
				var active = $('#active')[0].checked

				var alldata = '{'
				alldata += '"initial": "' + initial + '",'
				alldata += '"name": "' + name + '",'
				alldata += '"active":"' + active + '",'
				alldata += '"categoryId":' + idcat + ''
				alldata += '}'

				var link = ''
				var type = ''
				if (id == 0) {
					link = '/api/variants/add'
					type = 'post'
				} else {
					link = '/api/edit/variants/' + id + ''
					type = 'put'
				}

				$.ajax({
					url: link,
					type: type,
					contentType: 'application/json',
					data: alldata,
					success: function () {
						$('#modal').modal('toggle')
						getAllVariants()
					}
				})
			}

			function edit(id) {
				openModalVar()
				$.ajax({
					url: '/api/variants/' + id + '',
					type: 'get',
					contentType: 'application/json',
					success: function (data1) {
						$('#idvariants').val(data1.id)
						$('#categoryId').val(data1.categoryId)
						$('#initial').val(data1.initial)
						$('#name').val(data1.name)
						$('#active').prop("checked", true)
						$('.modal-title').html('Edit')
						$('#btn-save').html('Save Change').addClass("btn btn-warning")
					}
				})
			}

			function cekhapus(id) {
				openModalVar()
				$.ajax({
					url: '/api/variants/' + id + '',
					type: 'get',
					contentType: 'application/json',
					success: function (data1) {

						var str = "<form>"
						str += "<label>Are you sure you want to delete this?</label><br>"
						str += "<input type='hidden' value='" + id + "'id='idvariants'>"
						str += "<table>"
						str += "<tr>"
						str += "<td style='text-align :right'>Category</td>"
						str += "<td style='width:20px'></td>"
						str += "<td style='text-align :left'>" + data1.category.categoryName + "</td>"
						str += "</tr>"
						str += "<tr>"
						str += "<td style='text-align : right'>Initial</td>"
						str += "<td style='width:20px'></td>"
						str += "<td style='text-align : left'>" + data1.initial + "</td>"
						str += "</tr>"
						str += "<tr>"
						str += "<td style='text-align :right'>Name</td>"
						str += "<td style='width:20px'></td>"
						str += "<td style='text-align :left'>" + data1.name + "</td>"
						str += "</tr>"
						str += "<tr>"
						str += "<td style='text-align :right'>Active</td>"
						str += "<td style='width:20px'></td>"
						str += "<td style='text-align :left'><input checked type='checkbox' id='active' disabled></td>"
						str += "</tr>"
						str += "</table>"
						str += "</form>"

						$('.modal-title').html('Edit')
						$('.modal-body').html(str)
						$('#btn-save').off('click').on('click', hapus).html('Delete').addClass("btn btn-danger")
						$('#modal').modal('show')
					}
				})
			}
			function hapus() {
				var idcat = $('#categoryId').val()
				var id = $('#idvariants').val()
				var initial = $('#initial').val()
				var name = $('#name').val()
				var active = $('#active')[0].checked

				var alldata = '{'
				alldata += '"initial": "' + initial + '",'
				alldata += '"name": "' + name + '",'
				alldata += '"active":"' + active + '",'
				alldata += '"categoryId":' + idcat + ''
				alldata += '}'

				$.ajax({
					url: '/api/delete/variants/' + id + '',
					type: 'put',
					contentType: 'application/json',
					data: alldata,
					success: function () {
						$('#modal').modal('toggle')
						getAllVariants()
					}
				})
			}

			function search(key) {
				if (key.length != 0) {
					$.ajax({
						url: '/api/search/variants/' + key + '',
						type: 'get',
						contentType: 'application/json',
						success: function (datavariants) {
							var data = "<table class='table' 'border=1'>"
							data += "<thead>"
							data += "<tr>"
							data += "<th>Category</th>"
							data += "<th>Initial</th>"
							data += "<th>Name</th>"
							data += "<th style='text-align:center'>Active</th>"
							data += "<th colspan = '2' style='text-align:center'>Action</th>"
							data += "</tr>"
							data += "</thead>"
							data += "<tbody>"
							for (var i = 0; i < datavariants.length; i++) {
								data += "<tr>"
								data += "<td>" + datavariants[i].category.categoryName + "</td>"
								data += "<td>" + datavariants[i].initial + "</td>"
								data += "<td>" + datavariants[i].name + "</td>"
								data += "<td style='text-align:center'><input type='checkbox' name='active' checked disabled></td>"
								data += "<td style='text-align:center'><button class='btn btn-warning'; onclick='edit(" + datavariants[i].id + ")';>Edit</button></td>"
								data += "<td style='text-align:center'><button class='btn btn-danger'; onclick='cekhapus(" + datavariants[i].id + ")';>Delete</button></td>"
								data += "</tr>"
							}
							data += "</tbody>"
							data += "</table>"

							$('#inputdata').html(data)
						}
					})
				} else {
					getAllVariants()
				}

			}
		</script>
	</div>
</body>

</html>